searchNodes=[{"doc":"This library contains Bitcrowd's collection of tiny Ecto helpers. BitcrowdEcto.Schema is our default schema template which configures PK/FKs and timestamp types, among other things. BitcrowdEcto.Repo contains extensions for Ecto repos, like fetch/2 . BitcrowdEcto.Migrator contains a tool for migrating from within releases. BitcrowdEcto.Migration contains functions used in migrations. BitcrowdEcto.Changeset contains mostly validators. The validate_money/3 validator is enabled when you add ex_money as a dependency to your project. Note that you need to recompile bitcrowd_ecto when you add ex_money later. BitcrowdEcto.DateTime contains date/time helpers. BitcrowdEcto.Assertions has an assortment of useful ExUnit assertions related to Ecto schemas. BitcrowdEcto.Random contains functions that generate random tokens. Steps to release Replace the version number in mix.exs Set version number &amp; date in CHANGELOG.md Commit, push and open a PR for your release When the PR is merged: git tag - a &#39;vX.X.X&#39; git push -- tags mix hex . publish","ref":"BitcrowdEcto.html","title":"BitcrowdEcto","type":"module"},{"doc":"Useful little test assertions related to Ecto.Changeset.t/0 . Example Import this in your ExUnit.CaseTemplate : defmodule MyApp.TestCase do use ExUnit.CaseTemplate using do quote do import Ecto import Ecto.Changeset import Ecto.Query import BitcrowdEcto.Assertions end end end","ref":"BitcrowdEcto.Assertions.html","title":"BitcrowdEcto.Assertions","type":"module"},{"doc":"Asserts that a changeset contains a failed &quot;acceptance&quot; validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_acceptance_error_on/2","title":"BitcrowdEcto.Assertions.assert_acceptance_error_on/2","type":"function"},{"doc":"Allows to compare a DateTime field to another, testing whether they are roughly equal (d=5s). Delta defaults to 5 seconds and can be passed in optionally.","ref":"BitcrowdEcto.Assertions.html#assert_almost_coincide/3","title":"BitcrowdEcto.Assertions.assert_almost_coincide/3","type":"function"},{"doc":"Allows to compare a DateTime field to the present time.","ref":"BitcrowdEcto.Assertions.html#assert_almost_now/1","title":"BitcrowdEcto.Assertions.assert_almost_now/1","type":"function"},{"doc":"Asserts that the value of a datetime field changed to the present time. Example % TestSchema { datetime : nil } |&gt; Ecto.Changeset . change ( %{ datetime : DateTime . utc_now ( ) } ) |&gt; assert_change_to_almost_now ( :datetime )","ref":"BitcrowdEcto.Assertions.html#assert_change_to_almost_now/2","title":"BitcrowdEcto.Assertions.assert_change_to_almost_now/2","type":"function"},{"doc":"Asserts that a changeset contains a change of a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_changes/2","title":"BitcrowdEcto.Assertions.assert_changes/2","type":"function"},{"doc":"Asserts that a changeset contains a change of a given field to a given value. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_changes/3","title":"BitcrowdEcto.Assertions.assert_changes/3","type":"function"},{"doc":"","ref":"BitcrowdEcto.Assertions.html#assert_changeset_valid/1","title":"BitcrowdEcto.Assertions.assert_changeset_valid/1","type":"function"},{"doc":"Assert that a given function changes the count of a given database table. Example assert_count_difference Repo , Foo , 1 , fn -&gt; Repo . insert ( % Foo { } ) end","ref":"BitcrowdEcto.Assertions.html#assert_count_difference/4","title":"BitcrowdEcto.Assertions.assert_count_difference/4","type":"function"},{"doc":"Assert multiple database table count changes. See assert_count_difference/4 for details. Example assert_count_differences ( [ { MyApp.Foo , 1 } , { MyApp.Bar , - 1 } ] , fn -&gt; % MyApp.Foo { } |&gt; MyApp.Repo . insert ( ) % MyApp.Bar { id : 1 } |&gt; MyApp.Repo . delete ( ) end","ref":"BitcrowdEcto.Assertions.html#assert_count_differences/3","title":"BitcrowdEcto.Assertions.assert_count_differences/3","type":"function"},{"doc":"Asserts that a given function changes the integer fetched by another function by a delta. Example assert_difference fn -&gt; Repo . count ( Foo ) end , 1 fn -&gt; % Foo { } |&gt; Repo . insert ( ) end","ref":"BitcrowdEcto.Assertions.html#assert_difference/4","title":"BitcrowdEcto.Assertions.assert_difference/4","type":"function"},{"doc":"Asserts that a changeset contains a given error on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_error_on/4","title":"BitcrowdEcto.Assertions.assert_error_on/4","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;foreign_key&quot; constraint validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_foreign_constraint_error_on/2","title":"BitcrowdEcto.Assertions.assert_foreign_constraint_error_on/2","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;foreign_key&quot; constraint validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_foreign_key_constraint_error_on/2","title":"BitcrowdEcto.Assertions.assert_foreign_key_constraint_error_on/2","type":"function"},{"doc":"Asserts that a changeset contains a constraint on a given field. This function looks into the changeset's (internal) constraints field to see if a *_constraint function has been called on it. Tests using this do not need to actually perform the database operation. However, given that the constraints only work in combination with a corresponding database constraint, it is advisable to perform the operation and use assert_foreign_key_constraint_error_on/2 instead. Returns the changeset for chainability. Options The given options are used as match values against the constraint map. They loosely correspond to the options of Ecto.Changeset.foreign_key_constraint/2 , only :name becomes :constraint .","ref":"BitcrowdEcto.Assertions.html#assert_foreign_key_constraint_on/3","title":"BitcrowdEcto.Assertions.assert_foreign_key_constraint_on/3","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;format&quot; validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_format_error_on/2","title":"BitcrowdEcto.Assertions.assert_format_error_on/2","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;inclusion&quot; validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_inclusion_error_on/2","title":"BitcrowdEcto.Assertions.assert_inclusion_error_on/2","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;no_assoc&quot; constraint validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_no_assoc_constraint_error_on/2","title":"BitcrowdEcto.Assertions.assert_no_assoc_constraint_error_on/2","type":"function"},{"doc":"Asserts that a changeset contains a constraint on a given field. This function looks into the changeset's (internal) constraints field to see if a *_constraint function has been called on it. Tests using this do not need to actually perform the database operation. However, given that the constraints only work in combination with a corresponding database constraint, it is advisable to perform the operation and use assert_no_assoc_constraint_error_on/2 instead. Returns the changeset for chainability. Options The given options are used as match values against the constraint map. They loosely correspond to the options of Ecto.Changeset.no_assoc_constraint/2 , only :name becomes :constraint .","ref":"BitcrowdEcto.Assertions.html#assert_no_assoc_constraint_on/3","title":"BitcrowdEcto.Assertions.assert_no_assoc_constraint_on/3","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;number&quot; validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_number_error_on/2","title":"BitcrowdEcto.Assertions.assert_number_error_on/2","type":"function"},{"doc":"Asserts that an Ecto struct has a preloaded nested struct at a given path.","ref":"BitcrowdEcto.Assertions.html#assert_preloaded/2","title":"BitcrowdEcto.Assertions.assert_preloaded/2","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;required&quot; validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_required_error_on/2","title":"BitcrowdEcto.Assertions.assert_required_error_on/2","type":"function"},{"doc":"Assert that two lists are equal when sorted (Enum.sort). Example assert_sorted_equal [ :&quot;1&quot; , :&quot;2&quot; ] , [ :&quot;2&quot; , :&quot;1&quot; ] assert_sorted_equal ( [ %{ id : 2 } , %{ id : 1 } ] , [ %{ id : 1 , preload_nested_resource : %{ id : 5 } } , %{ id : 2 } ] , &amp; &amp;1 . id )","ref":"BitcrowdEcto.Assertions.html#assert_sorted_equal/2","title":"BitcrowdEcto.Assertions.assert_sorted_equal/2","type":"function"},{"doc":"","ref":"BitcrowdEcto.Assertions.html#assert_sorted_equal/3","title":"BitcrowdEcto.Assertions.assert_sorted_equal/3","type":"function"},{"doc":"Asserts that a changeset contains a failed &quot;unique&quot; constraint validation on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#assert_unique_constraint_error_on/2","title":"BitcrowdEcto.Assertions.assert_unique_constraint_error_on/2","type":"function"},{"doc":"Asserts that a changeset contains a constraint on a given field. This function looks into the changeset's (internal) constraints field to see if a *_constraint function has been called on it. Tests using this do not need to actually perform the database operation. However, given that the constraints only work in combination with a corresponding database constraint, it is advisable to perform the operation and use assert_unique_constraint_error_on/2 instead. Returns the changeset for chainability. Options The given options are used as match values against the constraint map. They loosely correspond to the options of Ecto.Changeset.unique_constraint/2 , only :name becomes :constraint .","ref":"BitcrowdEcto.Assertions.html#assert_unique_constraint_on/3","title":"BitcrowdEcto.Assertions.assert_unique_constraint_on/3","type":"function"},{"doc":"A better error helper that transforms the errors on a given field into a list of [&lt;message&gt;, &lt;value of the :validation metadata field&gt;] . If multiple validations failed, the list will contain more elements! That simple. Metadata By default, flat_errors_on/2 extracts metadata from the :validation and :constraint keys, as those are were Ecto stores its metadata. Custom metadata at different keys can be extracted using the :metadata option.","ref":"BitcrowdEcto.Assertions.html#flat_errors_on/3","title":"BitcrowdEcto.Assertions.flat_errors_on/3","type":"function"},{"doc":"Refutes that a changeset accepts changes to a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#refute_changes/2","title":"BitcrowdEcto.Assertions.refute_changes/2","type":"function"},{"doc":"","ref":"BitcrowdEcto.Assertions.html#refute_changeset_valid/1","title":"BitcrowdEcto.Assertions.refute_changeset_valid/1","type":"function"},{"doc":"Assert that a given function doesn't change the value fetched by another function. Example refute_difference fn -&gt; Repo . count ( Foo ) end , fn -&gt; Repo . insert ( % Foo { } ) end","ref":"BitcrowdEcto.Assertions.html#refute_difference/3","title":"BitcrowdEcto.Assertions.refute_difference/3","type":"function"},{"doc":"Asserts that a changeset does not contain an error on a given field. Returns the changeset for chainability.","ref":"BitcrowdEcto.Assertions.html#refute_errors_on/2","title":"BitcrowdEcto.Assertions.refute_errors_on/2","type":"function"},{"doc":"Refutes that an Ecto struct has a preloaded nested struct at a given path.","ref":"BitcrowdEcto.Assertions.html#refute_preloaded/2","title":"BitcrowdEcto.Assertions.refute_preloaded/2","type":"function"},{"doc":"Extensions for Ecto changesets.","ref":"BitcrowdEcto.Changeset.html","title":"BitcrowdEcto.Changeset","type":"module"},{"doc":"Validates that a field that has been changed.","ref":"BitcrowdEcto.Changeset.html#validate_changed/2","title":"BitcrowdEcto.Changeset.validate_changed/2","type":"function"},{"doc":"Validates a date field in the changeset is after the given reference date.","ref":"BitcrowdEcto.Changeset.html#validate_date_after/4","title":"BitcrowdEcto.Changeset.validate_date_after/4","type":"function"},{"doc":"Validates two date fields to be a date range, so if both are set the first field has to be before the second field. The error is placed on the later field. Examples validate_date_order ( changeset , :from , :to ) validate_date_order ( changeset , :from , :to , [ valid_orders : :lt ] ) validate_date_order ( changeset , :from , :to , [ formatter : &amp; Date . day_of_week / 1 ] )","ref":"BitcrowdEcto.Changeset.html#validate_date_order/4","title":"BitcrowdEcto.Changeset.validate_date_order/4","type":"function"},{"doc":"Validates a field timestamp to be after the given one","ref":"BitcrowdEcto.Changeset.html#validate_datetime_after/4","title":"BitcrowdEcto.Changeset.validate_datetime_after/4","type":"function"},{"doc":"Validates two datetime fields to be a time range, so if both are set the first has to be before the second field. The error is placed on the later field. Examples validate_datetime_order ( changeset , :from , :to ) validate_datetime_order ( changeset , :from , :to , [ valid_orders : :lt ] ) validate_datetime_order ( changeset , :from , :to , [ formatter : &amp; DateTime . to_time / 1 ] )","ref":"BitcrowdEcto.Changeset.html#validate_datetime_order/4","title":"BitcrowdEcto.Changeset.validate_datetime_order/4","type":"function"},{"doc":"Validates that an email has valid format. Ignores nil values. Compliance For a good list of valid/invalid emails, see https://gist.github.com/cjaoude/fd9910626629b53c4d25 The regex used in this validator doesn't understand half of the inputs, but we don't really care for now. Validating super strange emails is not a sport we want to compete in. Options :max_length - restricts the maximum length of the input, defaults to 320 :only_web - requires a dot in the domain part, e.g. domain.tld , defaults to true","ref":"BitcrowdEcto.Changeset.html#validate_email/3","title":"BitcrowdEcto.Changeset.validate_email/3","type":"function"},{"doc":"Validates a field timestamp to be in the future, if present","ref":"BitcrowdEcto.Changeset.html#validate_future_datetime/3","title":"BitcrowdEcto.Changeset.validate_future_datetime/3","type":"function"},{"doc":"Validates a changeset field with hexadecimal color format","ref":"BitcrowdEcto.Changeset.html#validate_hex_color/2","title":"BitcrowdEcto.Changeset.validate_hex_color/2","type":"function"},{"doc":"Validates that a field is not changed from its current value, unless the current value is nil.","ref":"BitcrowdEcto.Changeset.html#validate_immutable/2","title":"BitcrowdEcto.Changeset.validate_immutable/2","type":"function"},{"doc":"Validates a t:Money.t value according to the given options. Examples validate_money ( changeset , :amount , less_than : Money . new ( &quot;100.00&quot; , :USD ) ) validate_money ( changeset , :amount , greater_than_or_equal_to : Money . new ( &quot;100.00&quot; , :USD ) ) validate_money ( changeset , :amount , currency : :USD )","ref":"BitcrowdEcto.Changeset.html#validate_money/3","title":"BitcrowdEcto.Changeset.validate_money/3","type":"function"},{"doc":"Validates two fields to be a range, so if both are set the first has to be before the second field. The error is placed on the second field. Examples validate_order ( changeset , :from , :to , :to_is_after_from ) validate_order ( changeset , :from , :to , :to_is_after_from , [ compare_fun : fn a , b -&gt; String . length ( a ) &gt; String . length ( b ) end ] ) validate_order ( changeset , :from , :to , :to_is_after_from , [ formatter : &amp; String . length / 1 ] )","ref":"BitcrowdEcto.Changeset.html#validate_order/5","title":"BitcrowdEcto.Changeset.validate_order/5","type":"function"},{"doc":"Validates a field timestamp to be in the past, if present","ref":"BitcrowdEcto.Changeset.html#validate_past_datetime/3","title":"BitcrowdEcto.Changeset.validate_past_datetime/3","type":"function"},{"doc":"Validates that a field has changed in a defined way. Examples validate_transition ( changeset , field , [ { &quot;foo&quot; , &quot;bar&quot; } , { &quot;foo&quot; , &quot;yolo&quot; } ] ) This marks the changeset invalid unless the value of :field is currently &quot;foo&quot; and is changed to &quot;bar&quot; or &quot;yolo&quot; . If the field is not changed, a {state, state} transition has to be present in the list of transitions.","ref":"BitcrowdEcto.Changeset.html#validate_transition/3","title":"BitcrowdEcto.Changeset.validate_transition/3","type":"function"},{"doc":"Validates a field url to be qualified url","ref":"BitcrowdEcto.Changeset.html#validate_url/2","title":"BitcrowdEcto.Changeset.validate_url/2","type":"function"},{"doc":"","ref":"BitcrowdEcto.Changeset.html#t:validate_email_option/0","title":"BitcrowdEcto.Changeset.validate_email_option/0","type":"type"},{"doc":"","ref":"BitcrowdEcto.Changeset.html#t:validate_money_option/0","title":"BitcrowdEcto.Changeset.validate_money_option/0","type":"type"},{"doc":"Functions to work with date and time values.","ref":"BitcrowdEcto.DateTime.html","title":"BitcrowdEcto.DateTime","type":"module"},{"doc":"Works similar to Timex.beginning_of_day/3 , but way more simple. Behaviour Nulls the time fields of the DateTime and keeps the rest. Examples iex&gt; beginning_of_day ( ~U[2022-04-07 07:21:22.036Z] ) ~U[2022-04-07 00:00:00.000000Z]","ref":"BitcrowdEcto.DateTime.html#beginning_of_day/1","title":"BitcrowdEcto.DateTime.beginning_of_day/1","type":"function"},{"doc":"Calculates the beginning of last month. Behaviour Goes to this month's beginning, subtracts 15 days, and goes back to the month's beginning. Should be relatively safe. Examples iex&gt; beginning_of_last_month ( ~U[2022-04-07 07:21:22.036Z] ) ~U[2022-03-01 00:00:00.000000Z] iex&gt; beginning_of_last_month ( ~U[2022-02-07 07:21:22.036Z] ) ~U[2022-01-01 00:00:00.000000Z]","ref":"BitcrowdEcto.DateTime.html#beginning_of_last_month/1","title":"BitcrowdEcto.DateTime.beginning_of_last_month/1","type":"function"},{"doc":"Works similar to Timex.beginning_of_day/3 , but way more simple. Behaviour Sets day to 1 and nulls the time fields. Examples iex&gt; beginning_of_month ( ~U[2022-04-07 07:21:22.036Z] ) ~U[2022-04-01 00:00:00.000000Z]","ref":"BitcrowdEcto.DateTime.html#beginning_of_month/1","title":"BitcrowdEcto.DateTime.beginning_of_month/1","type":"function"},{"doc":"Calculates the beginning of next month. Behaviour Goes to this month's beginning, adds 45 days, and goes back to the month's beginning. Should be relatively safe. Examples iex&gt; beginning_of_next_month ( ~U[2022-04-07 07:21:22.036Z] ) ~U[2022-05-01 00:00:00.000000Z] iex&gt; beginning_of_next_month ( ~U[2022-02-07 07:21:22.036Z] ) ~U[2022-03-01 00:00:00.000000Z]","ref":"BitcrowdEcto.DateTime.html#beginning_of_next_month/1","title":"BitcrowdEcto.DateTime.beginning_of_next_month/1","type":"function"},{"doc":"Calculates the beginning of tomorrow, equalizing day length differences due to DST. Behaviour Adds 1.5d to today's midnight and goes back to midnight. Should be relatively safe. Examples iex&gt; beginning_of_tomorrow ( ~U[2022-04-07 07:21:22.036Z] ) ~U[2022-04-08 00:00:00.000000Z] iex&gt; ~U[2020-03-29 12:00:00.000Z] ...&gt; |&gt; DateTime . shift_zone! ( &quot;Europe/Berlin&quot; ) ...&gt; |&gt; beginning_of_tomorrow ( ) ...&gt; |&gt; DateTime . to_iso8601 ( ) &quot;2020-03-30T00:00:00.000000+02:00&quot;","ref":"BitcrowdEcto.DateTime.html#beginning_of_tomorrow/1","title":"BitcrowdEcto.DateTime.beginning_of_tomorrow/1","type":"function"},{"doc":"Calculates the beginning of yesterday, equalizing day length differences due to DST. Behaviour Subtracts 0.5d from today's midnight and goes back to midnight. Should be relatively safe. Examples iex&gt; beginning_of_yesterday ( ~U[2022-04-07 07:21:22.036Z] ) ~U[2022-04-06 00:00:00.000000Z] iex&gt; ~U[2020-03-29 12:00:00.000Z] ...&gt; |&gt; DateTime . shift_zone! ( &quot;Europe/Berlin&quot; ) ...&gt; |&gt; beginning_of_yesterday ( ) ...&gt; |&gt; DateTime . to_iso8601 ( ) &quot;2020-03-28T00:00:00.000000+01:00&quot;","ref":"BitcrowdEcto.DateTime.html#beginning_of_yesterday/1","title":"BitcrowdEcto.DateTime.beginning_of_yesterday/1","type":"function"},{"doc":"Converts a {&lt;value&gt;, &lt;unit&gt;} tuple into seconds. #Examples iex&gt; in_seconds ( { 99 , :second } ) 99 iex&gt; in_seconds ( { 1 , :minute } ) 60 iex&gt; in_seconds ( { 1 , :hour } ) 3600 iex&gt; in_seconds ( { 1 , :day } ) 86400 iex&gt; in_seconds ( { 1 , :week } ) 604800","ref":"BitcrowdEcto.DateTime.html#in_seconds/1","title":"BitcrowdEcto.DateTime.in_seconds/1","type":"function"},{"doc":"Works similar to Timex.shift/3 , but way more simple. Behaviour Semantics are like DateTime.add/3 . TimeZone-awareness when using tzdata. DateTime, e.g. &quot;2020-03-29 14:00 Europe/Berlin&quot; - 1 day = &quot;2020-03-28 13:00&quot; as March 29th only had 23 hours due to DST. Examples iex&gt; shift ( ~U[2022-04-07 07:21:22.036Z] , 15 ) ~U[2022-04-07 07:21:37.036Z] iex&gt; shift ( ~U[2022-04-07 07:21:22.036Z] , - 3600 ) ~U[2022-04-07 06:21:22.036Z] iex&gt; shift ( ~U[2022-04-07 07:21:22.036Z] , { 1 , :day } ) ~U[2022-04-08 07:21:22.036Z] iex&gt; ~U[2020-03-29 12:00:00.000Z] ...&gt; |&gt; DateTime . shift_zone! ( &quot;Europe/Berlin&quot; ) ...&gt; |&gt; shift ( { - 1 , :day } ) ...&gt; |&gt; DateTime . to_iso8601 ( ) &quot;2020-03-28T13:00:00.000+01:00&quot;","ref":"BitcrowdEcto.DateTime.html#shift/2","title":"BitcrowdEcto.DateTime.shift/2","type":"function"},{"doc":"","ref":"BitcrowdEcto.DateTime.html#t:period/0","title":"BitcrowdEcto.DateTime.period/0","type":"type"},{"doc":"","ref":"BitcrowdEcto.DateTime.html#t:unit/0","title":"BitcrowdEcto.DateTime.unit/0","type":"type"},{"doc":"Utilities for migrations.","ref":"BitcrowdEcto.Migration.html","title":"BitcrowdEcto.Migration","type":"module"},{"doc":"This function grants data manipulation privileges for a given schema to a given role. Use this when you have a setup where your &quot;runtime&quot; user is deprived of all DDL privileges (i.e., it can't create or modify tables, etc.), but your migration user is allowed to do so. In particular, the following GRANTS are executed: GRANT SELECT , INSERT , UPDATE , DELETE ON ALL TABLES GRANT ALL ON ALL FUNCTIONS GRANT ALL ON ALL SEQUENCES Usage The easiest way of using this is to issue the command after every CREATE SCHEMA call: def change do execute ( &quot;CREATE SCHEMA foo;&quot; , &quot;DROP SCHEMA foo;&quot; ) if direction ( ) == :up do BitcrowdEcto.Migration . grant_dml_privileges_on_schema ( &quot;foo&quot; , &quot;mydmlrole&quot; ) end end Options default boolean indicating whether the privileges should automatically be granted for future objects , defaults to true","ref":"BitcrowdEcto.Migration.html#grant_dml_privileges_on_schema/3","title":"BitcrowdEcto.Migration.grant_dml_privileges_on_schema/3","type":"function"},{"doc":"Release migration logic for repositories. Can deal with normal repositories &amp; multi-tenant repositories. Usage In the simplest case, add the Migrator to your repository: defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres use BitcrowdEcto.Migrator end and call the migrator from your release: $ bin/my_app eval &#39;MyApp.Repo.up()&#39; Multi-Tenant repositories For multi-tenant repositories, you need to provide a list of tenants (= PG schemas) by overriding the known_prefixes/0 function on your repository: defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres use BitcrowdEcto.Migrator def known_prefixes do [ &quot;tenant_a&quot; , &quot;tenant_b&quot; ] end end This will make the migrator apply migrations from the priv/repo/tenant_migrations directory onto schemas tenant_a and tenant_b . The schemas will be created if necessary. Mix tasks for development In normal development without multi-tenancy, the usual Ecto mix tasks will work just fine. When using tenant schemas, the normal Ecto mix tasks will only apply the &quot;global&quot; (i.e. non-prefixed migrations) from priv/repo/migrations , which is not enough. You can define your own Mix tasks calling the up/0 and down/1 functions on your repository: defmodule Mix.Tasks.MyApp.Migrate do use Mix.Task @shortdoc &quot;Migrates our repository&quot; @moduledoc &quot;Migrates the repository including the tenant schemas&quot; @impl true def run ( args ) do Mix.Task . run ( &quot;app.config&quot; , args ) MyApp.Repo . up ( ) end end defmodule Mix.Tasks.MyApp.Rollback do use Mix.Task @shortdoc &quot;Rolls back our repository&quot; @moduledoc &quot;Rolls back the repository including the tenant schemas&quot; @impl true def run ( args ) do Mix.Task . run ( &quot;app.config&quot; , args ) { [ to : to ] , _ } = OptionParser . parse! ( args , strict : [ to : :integer ] , aliases : [ ] ) MyApp.Repo . down ( to ) end end Stopping the application if migrations are down In some setups (e.g. parallel starts of Kubernetes jobs for migrations and your app workload) you may want to abort startup if migrations haven't been applied. Use the ensure_up!/0 function to raise an exception in such cases. $ bin/my_app eval &#39;MyApp.Repo.ensure_up!()&#39; [...] ** (RuntimeError) Migrations not up! 20220101120000_create_foo_table.exs [...] $ echo $? 1 $ bin/my_app eval &#39;MyApp.Repo.up()&#39; [...] $ bin/my_app eval &#39;MyApp.Repo.ensure_up!()&#39; [...] $ echo $? 0","ref":"BitcrowdEcto.Migrator.html","title":"BitcrowdEcto.Migrator","type":"behaviour"},{"doc":"Rolls back both the main schemas/tables and the tenant schemas to a given version.","ref":"BitcrowdEcto.Migrator.html#c:down/1","title":"BitcrowdEcto.Migrator.down/1","type":"callback"},{"doc":"Checks that all migrations have been run or raises an exception otherwise.","ref":"BitcrowdEcto.Migrator.html#c:ensure_up!/0","title":"BitcrowdEcto.Migrator.ensure_up!/0","type":"callback"},{"doc":"Called when the migrator experiences an exception.","ref":"BitcrowdEcto.Migrator.html#c:handle_migrator_exception/2","title":"BitcrowdEcto.Migrator.handle_migrator_exception/2","type":"callback"},{"doc":"Returns the list of prefixes used on this repository.","ref":"BitcrowdEcto.Migrator.html#c:known_prefixes/0","title":"BitcrowdEcto.Migrator.known_prefixes/0","type":"callback"},{"doc":"Migrates both the &quot;main&quot; (i.e. non-tenant) schemas/tables and the tenant schemas to their latest version.","ref":"BitcrowdEcto.Migrator.html#c:up/0","title":"BitcrowdEcto.Migrator.up/0","type":"callback"},{"doc":"Various random value generators.","ref":"BitcrowdEcto.Random.html","title":"BitcrowdEcto.Random","type":"module"},{"doc":"Generates a random token from an alphabet designed to have no ambiguities.","ref":"BitcrowdEcto.Random.html#unambiguous_human_token/1","title":"BitcrowdEcto.Random.unambiguous_human_token/1","type":"function"},{"doc":"Generates a random token suitable for inclusion in URLs.","ref":"BitcrowdEcto.Random.html#url_token/1","title":"BitcrowdEcto.Random.url_token/1","type":"function"},{"doc":"Generates a UUID V4.","ref":"BitcrowdEcto.Random.html#uuid/0","title":"BitcrowdEcto.Random.uuid/0","type":"function"},{"doc":"Extensions for Ecto repos. Usage defmodule MyApp.Repo do use Ecto.Repo , otp_app : :my_app , adapter : Ecto.Adapters.Postgres use BitcrowdEcto.Repo end","ref":"BitcrowdEcto.Repo.html","title":"BitcrowdEcto.Repo","type":"behaviour"},{"doc":"Acquires an advisory lock for a named resource. Advisory locks are helpful when you don't have a specific row to lock, but also don't want to lock an entire table. See https://www.postgresql.org/docs/9.4/explicit-locking.html#ADVISORY-LOCKS Example MyApp.Repo . transaction ( fn -&gt; MyApp.Repo . advisory_lock ( :foo ) # Advisory lock is held until end of transaction end ) A note on the advisory lock key pg_advisory_xact_lock() has two versions: One which you pass a 64-bit signed integer as the lock key, and one which you pass two 32-bit integers as the keys (e.g., one &quot;application&quot; key and one specific lock key), in which case PostgreSQL concatenates them into a 64-bit value. In any case you need to pass integers. We decided that we wanted to have atom or string keys for better readability. Hence, in= order to make PostgreSQL happy, we hash these strings into 64 bits signed ints. 64 bits make a pretty big number already, so it is quite unlikely that two of our keys (or keys of other libraries that use advisory locks, e.g. Oban) collide. But for an extra false sense of safety we use a crypto hash algorithm to ensure that keys spread out over the domain uniformly. Luckily, taking a prefix of a cryptographic hash does not break its uniformity.","ref":"BitcrowdEcto.Repo.html#c:advisory_xact_lock/1","title":"BitcrowdEcto.Repo.advisory_xact_lock/1","type":"callback"},{"doc":"Allows to conveniently count a queryable.","ref":"BitcrowdEcto.Repo.html#c:count/1","title":"BitcrowdEcto.Repo.count/1","type":"callback"},{"doc":"Fetches a record by ID or returns a &quot;tagged&quot; error tuple. See fetch/2 .","ref":"BitcrowdEcto.Repo.html#c:fetch/2","title":"BitcrowdEcto.Repo.fetch/2","type":"callback"},{"doc":"Fetches a record by ID or returns a &quot;tagged&quot; error tuple. See fetch_by/3 for options.","ref":"BitcrowdEcto.Repo.html#c:fetch/3","title":"BitcrowdEcto.Repo.fetch/3","type":"callback"},{"doc":"Fetches a record by given clauses or returns the result wrapped in an ok tuple. See fetch_by/3 .","ref":"BitcrowdEcto.Repo.html#c:fetch_by/2","title":"BitcrowdEcto.Repo.fetch_by/2","type":"callback"},{"doc":"Fetches a record by given clauses or returns the result wrapped in an ok tuple. On error, a &quot;tagged&quot; error tuple is returned that contains the original queryable or module as the tag, e.g. {:error, {:not_found, Account}} for a fetch_by(Account, id: 1) call. This function can also apply row locks. Options lock any of [:no_key_update, :update] (defaults to false ) preload allows to preload associations","ref":"BitcrowdEcto.Repo.html#c:fetch_by/3","title":"BitcrowdEcto.Repo.fetch_by/3","type":"callback"},{"doc":"","ref":"BitcrowdEcto.Repo.html#t:fetch_option/0","title":"BitcrowdEcto.Repo.fetch_option/0","type":"type"},{"doc":"","ref":"BitcrowdEcto.Repo.html#t:fetch_result/0","title":"BitcrowdEcto.Repo.fetch_result/0","type":"type"},{"doc":"","ref":"BitcrowdEcto.Repo.html#t:lock_mode/0","title":"BitcrowdEcto.Repo.lock_mode/0","type":"type"},{"doc":"An opinionated set of defaults for Ecto schemas. Uses Ecto.Schema and imports Ecto.Changeset and BitcrowdEcto.Changeset Configures an autogenerated PK of type binary_id Configures FKs to be of type binary_id Sets timestamp type to utc_datetime_usec Defines a type t as a struct of the schema module. Defines an id type Usage defmodule MyApp.MySchema do use BitcrowdEcto.Schema end Or if you table lives in a different Postgres schema: defmodule MyApp.MySchema do use BitcrowdEcto.Schema , prefix : &quot;foo&quot; end","ref":"BitcrowdEcto.Schema.html","title":"BitcrowdEcto.Schema","type":"module"},{"doc":"Safely converts a string into an enum member atom. Raises if conversion is not possible.","ref":"BitcrowdEcto.Schema.html#to_enum_member!/3","title":"BitcrowdEcto.Schema.to_enum_member!/3","type":"function"},{"doc":"Safely converts a string into an enum member atom. Returns nil if conversion is not posssible. Example iex&gt; to_enum_member ( TestEnumSchema , :some_enum , &quot;foo&quot; ) :foo","ref":"BitcrowdEcto.Schema.html#to_enum_member/3","title":"BitcrowdEcto.Schema.to_enum_member/3","type":"function"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2021 Bitcrowd GmbH Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"This library contains Bitcrowd's collection of tiny Ecto helpers. BitcrowdEcto.Schema is our default schema template which configures PK/FKs and timestamp types, among other things. BitcrowdEcto.Repo contains extensions for Ecto repos, like fetch/2 . BitcrowdEcto.Migrator contains a tool for migrating from within releases. BitcrowdEcto.Migration contains functions used in migrations. BitcrowdEcto.Changeset contains mostly validators. The validate_money/3 validator is enabled when you add ex_money as a dependency to your project. Note that you need to recompile bitcrowd_ecto when you add ex_money later. BitcrowdEcto.DateTime contains date/time helpers. BitcrowdEcto.Assertions has an assortment of useful ExUnit assertions related to Ecto schemas. BitcrowdEcto.Random contains functions that generate random tokens.","ref":"readme.html","title":"BitcrowdEcto","type":"extras"},{"doc":"Replace the version number in mix.exs Set version number &amp; date in CHANGELOG.md Commit, push and open a PR for your release When the PR is merged: git tag - a &#39;vX.X.X&#39; git push -- tags mix hex . publish","ref":"readme.html#steps-to-release","title":"BitcrowdEcto - Steps to release","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Add error_tag option to BitcrowdEcto.Repo.fetch_by/3 and friends to allow overriding the queryable in the error result.","ref":"changelog.html#0-13-2-2022-12-19","title":"Changelog - [0.13.2] - 2022-12-19","type":"extras"},{"doc":"Fixed Fix dependency specifications by restoring the :only options and explicitly listing conflicting packages. See https://github.com/kipcole9/money/issues/142 for explanation.","ref":"changelog.html#0-13-1-2022-09-21","title":"Changelog - [0.13.1] - 2022-09-21","type":"extras"},{"doc":"NOTE: 0.13.0 needed to be retired due to a corrupt dependency tree listing all dev/test dependencies as prod dependencies. Add BitcrowdEcto.Changeset.validate_money/3 for validating Money values from ex_money , which is introduced as an optional dependency.","ref":"changelog.html#0-13-0-2022-09-14","title":"Changelog - [0.13.0] - 2022-09-14","type":"extras"},{"doc":"Added Add BitcrowdEcto.DateTime.beginning_of_month/1 . Add BitcrowdEcto.DateTime.beginning_of_last_month/1 . Add BitcrowdEcto.DateTime.beginning_of_next_month/1 . Add BitcrowdEcto.DateTime.beginning_of_yesterday/1 . Add BitcrowdEcto.DateTime.beginning_of_tomorrow/1 .","ref":"changelog.html#0-12-0-2022-06-21","title":"Changelog - [0.12.0] - 2022-06-21","type":"extras"},{"doc":"Add BitcrowdEcto.Changeset.validate_date_after/3 Validates a date field in the changeset is after the given reference date. Add BitcrowdEcto.Changeset.validate_hex_color/2 validates a changeset field has hexadecimal color format. Add BitcrowdEcto.Assertions.assert_changeset_valid/1 . Add BitcrowdEcto.Assertions.refute_changeset_valid/1 .","ref":"changelog.html#0-11-0-2022-06-09","title":"Changelog - [0.11.0] - 2022-06-09","type":"extras"},{"doc":"Added New BitcrowdEcto.Assertions.assert_*_constraint_on/2 matchers assert on constraints on changesets without going to the database. Add BitcrowdEcto.DateTime.shift/2 and BitcrowdEcto.DateTime.beginning_of_day/1 . Changed BREAKING: Stopped inspect ing the from / to fields in validate_transition/3 error details. Previously atom columns (e.g. from Ecto.Enum ) would result in [from: &quot;:foo&quot;, to: &quot;:bar&quot;] error details, now these atoms are inserted unchanged as [from: :foo, to: :bar] BREAKING: Removed :field from validate_transition/3 error details as it is redundant with the error field. Deprecated BitcrowdEcto.Assertions.assert_foreign_constraint_error_on/2 in favour of new assert_foreign_key_constraint_error_on/2 . Constraint assert functions are all called after the Ecto.Changeset.*_constraint functions now, not after internal error type names.","ref":"changelog.html#0-10-0-2022-04-28","title":"Changelog - [0.10.0] - 2022-04-28","type":"extras"},{"doc":"Added Add BitcrowdEcto.Assertions.assert_change_to_almost_now/2 to assert that the value of a datetime field changed to the present time. Add BitcrowdEcto.Schema.to_enum_member/3 and BitcrowdEcto.Schema.to_enum_member!/3 , functions that safely convert a string to the member of an enum based on reflection on the given schema. Changed BREAKING: Add :only_web option to BitcrowdEcto.Changeset.validate_email/3 that enforces a dot in the host part of the email address (e.g. foo@example.net is valid, foo@example is not). Defaults to true .","ref":"changelog.html#0-9-0-2022-03-25","title":"Changelog - [0.9.0] - 2022-03-25","type":"extras"},{"doc":"Changed BREAKING: Drop the BitcrowdEcto.Migration.grant_dml_privileges_on_schema/2 variant that reads from a configuration variable. However, the keyword list on grant_dml_privileges_on_schema/3 has become optional, so effectively there is a different /2 now.","ref":"changelog.html#0-8-0-2022-03-03","title":"Changelog - [0.8.0] - 2022-03-03","type":"extras"},{"doc":"Added Add BitcrowdEcto.Migration for migration utilities, first util is grant_dml_privileges_on_schema/2 that GRANT s certain privileges to a Postgres role.","ref":"changelog.html#0-7-0-2022-03-02","title":"Changelog - [0.7.0] - 2022-03-02","type":"extras"},{"doc":"Added Add BitcrowdEcto.Random containing various random token generators. Add validate_past_datetime/3 , validate_future_datetime/3 , validate_datetime_after/4 , validate_date_order/4 , validate_datetime_order/4 and validate_order/5 to BitcrowdEcto.Changeset .","ref":"changelog.html#0-6-0-2022-02-10","title":"Changelog - [0.6.0] - 2022-02-10","type":"extras"},{"doc":"Added Add Migrator.ensure_up!/0 to check whether all migrations are up.","ref":"changelog.html#0-5-0-2022-02-04","title":"Changelog - [0.5.0] - 2022-02-04","type":"extras"},{"doc":"Added Add handle_migrator_exception/2 callback to Migrator to allow exception reporting.","ref":"changelog.html#0-4-0-2022-01-28","title":"Changelog - [0.4.0] - 2022-01-28","type":"extras"},{"doc":"Added Add missing assert_sorted_equal/3 .","ref":"changelog.html#0-3-1-2022-01-17","title":"Changelog - [0.3.1] - 2022-01-17","type":"extras"},{"doc":"Added Add assert_almost_now/1 , assert_almost_coincide/3 and assert_sorted_equal/2 to BitcrowdEcto.Assertions .","ref":"changelog.html#0-3-0-2022-01-17","title":"Changelog - [0.3.0] - 2022-01-17","type":"extras"},{"doc":"Added Add BitcrowdEcto.DateTime.in_seconds/1 .","ref":"changelog.html#0-2-0-2022-01-17","title":"Changelog - [0.2.0] - 2022-01-17","type":"extras"},{"doc":"Initial release to the public 🎉","ref":"changelog.html#0-1-0-2022-01-07","title":"Changelog - [0.1.0] - 2022-01-07","type":"extras"}]